#include "DHT.h"
#include<LiquidCrystal_I2C.h>
#include <Servo.h>

LiquidCrystal_I2C lcd(0x27,16,2);
Servo myservo;

DHT dht1;
DHT dht2;
DHT dht3;
DHT dht4;

float temperature1;
float temperature2;
float temperature3;
float temperature4;



int current = 0;
int temp = 70;

void setup()
{
  Serial.begin(9600);
  myservo.attach(PIN_PD0);
  dht1.setup(PIN_PC0);
  dht2.setup(PIN_PC1);
  dht3.setup(PIN_PC2);
  dht4.setup(PIN_PC3);
  lcd.begin();
  lcd.backlight();
  lcd.setCursor(0,0);

}

void loop()
{
  LCD();
  
  //  t4
  if (temperature1 < temp && temperature2 < temp && temperature3 < temp &&temperature4 >= temp ) { 
    reset(365);
  }
  
  //t3
  else if (temperature1 < temp && temperature2 < temp && temperature3 >= temp &&temperature4 < temp ) { 
    reset(730);
  }

  //t2
  else if (temperature1 < temp && temperature2 >= temp && temperature3 < temp &&temperature4 < temp  ) { 
    reset(1095);
  }

  //t1
  else if (temperature2 < temp && temperature3 < temp &&temperature4 < temp ){
  reset(0);  
  }
  
  //t1t2t3t4
  else if (temperature1 >= temp && temperature2 >= temp && temperature3 >= temp &&temperature4 >= temp ) { 
  reset(0);
  myservo.writeMicroseconds(0); 
  delay(365);
  myservo.writeMicroseconds(1450); 
  delay(1000);
  myservo.writeMicroseconds(0);
  delay(365);
  myservo.writeMicroseconds(1450); 
  delay(1000);
  myservo.writeMicroseconds(0);
  delay(365);
  myservo.writeMicroseconds(1450); 
  delay(1000);
  myservo.writeMicroseconds(0);
  delay(365);
  myservo.writeMicroseconds(1450); 
  delay(1000);
  myservo.writeMicroseconds(3000); 
  delay(1400);
  myservo.writeMicroseconds(1450); 
  delay(1000);
  }
  
  // t1t2
  else if (temperature1 >= temp && temperature2 >= temp && temperature3 < temp &&temperature4 < temp ) {
    reset(0);
    myservo.writeMicroseconds(3000); 
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(0);
    delay(365);
    myservo.writeMicroseconds(1450); 

    
  }
  
  //t1t3
  else if (temperature1 >= temp && temperature2 < temp && temperature3 >= temp &&temperature4 < temp ) {
    reset(0);
  myservo.writeMicroseconds(0); 
  delay(720);
  myservo.writeMicroseconds(1450); 
  delay(1000);
  myservo.writeMicroseconds(3000);
  delay(720);
  myservo.writeMicroseconds(1450); 
  }
   
  //t1t4
  else if (temperature1 >= temp && temperature2 < temp && temperature3 < temp &&temperature4 >= temp ) {
    reset(0);
  myservo.writeMicroseconds(0); 
  delay(365);
  myservo.writeMicroseconds(1450); 
  delay(1000);
  myservo.writeMicroseconds(3000);
  delay(365);
  myservo.writeMicroseconds(1450); 

    
  }
  

  //t2t3
  else if (temperature1 < temp && temperature2 >= temp && temperature3 >= temp &&temperature4 < temp ) {
    reset(1095);
    myservo.writeMicroseconds(3000);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(0);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    }

  //t2t4
  else if (temperature1 < temp && temperature2 >= temp && temperature3 < temp &&temperature4 >= temp ) {
    
    reset(365);
    myservo.writeMicroseconds(0);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(0);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(3000);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(3000);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
  }

  //t3t4
  else if (temperature1 < temp && temperature2 < temp && temperature3 >= temp && temperature4 >= temp ) {
    
    reset(730);
    myservo.writeMicroseconds(3000);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(0);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
  }

  //t123
  else if (temperature1 >= temp && temperature2 >= temp && temperature3 >= temp && temperature4 < temp ) {
    reset(0);
    myservo.writeMicroseconds(3000);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(3000);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(0);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(0);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    
  }
  //t143
  else if (temperature1 >= temp && temperature2 < temp && temperature3 >= temp && temperature4 >= temp ) {
    reset(0);
    myservo.writeMicroseconds(0);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(0);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(3000);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(3000);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    
  }

  //t234
  else if (temperature1 < temp && temperature2 >= temp && temperature3 >= temp && temperature4 >= temp ) {
    reset(1095);
    myservo.writeMicroseconds(3000);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(3000);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(0);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(0);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    
  }
  //t214
  else if (temperature1 >= temp && temperature2 >= temp && temperature3 < temp && temperature4 >= temp ) {
    reset(1095);
    myservo.writeMicroseconds(0);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(0);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(3000);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    myservo.writeMicroseconds(3000);
    delay(365);
    myservo.writeMicroseconds(1450); 
    delay(1000);
    
  }



}



void reset(int r) {
  
  if (r == current) {
    myservo.writeMicroseconds(1450); 
    delay(1000);
  }
  else if (r > current ) {
    if ((r - current) > 730) {
      myservo.writeMicroseconds(3000);
      delay(365);
      myservo.writeMicroseconds(1450); 
      delay(1000);
    }
    else {
      myservo.writeMicroseconds(0);
      delay(r - current);
      myservo.writeMicroseconds(1450); 
      delay(1000);
    }
    
  }
  else {
    if (current - r > 730) {
      myservo.writeMicroseconds(0);
      delay(365);
      myservo.writeMicroseconds(1450); 
      delay(1000);
    }
    else {
      myservo.writeMicroseconds(3000);
      delay(current - r);
      myservo.writeMicroseconds(1450); 
      delay(1000);
    }
  }
  current = r;
  
}

void LCD() {
  temperature1 = dht1.getTemperature();
  temperature2 = dht2.getTemperature();
  temperature3 = dht3.getTemperature();
  temperature4 = dht4.getTemperature();
  lcd.clear();
  lcd.print(temperature1);
  lcd.print(" C  ");
  lcd.print(temperature2);
  lcd.print(" C");
  lcd.setCursor(0,1);
  lcd.print(temperature3);
  lcd.print(" C  ");
  lcd.print(temperature4);
  lcd.print(" C");
  delay(1000);
  
 }
